#include "stdafx.h"
#include "TestSounds.h"
#include "TestSoundsDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//The one and only CTestSoundsApp object
#pragma warning(suppress: 26426)
CTestSoundsApp theApp;


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestSoundsApp, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

BOOL CTestSoundsApp::InitInstance()
{
  INITCOMMONCONTROLSEX InitCtrls;
  InitCtrls.dwSize = sizeof(InitCtrls);
  InitCtrls.dwICC = ICC_WIN95_CLASSES;
  InitCommonControlsEx(&InitCtrls);

  //Let the base class do its thing
  __super::InitInstance();

  SetRegistryKey(_T("Local AppWizard-Generated Applications"));

  //Initialize and registry the sounds manager
  m_SoundsManager.Initialize(AfxGetAppName(), AFX_IDS_APP_TITLE, AfxGetResourceHandle());
  const HRESULT hr{m_SoundsManager.IsRegistered()};
  if (FAILED(hr) || (hr == S_FALSE))
    m_SoundsManager.Register();

  //Play the startup sound
  m_SoundsManager.PlaySound(IDR_STARTUP_SOUND, SND_ASYNC);

  //Show the main dialog
  CTestSoundsDlg dlg;
  m_pMainWnd = &dlg;
  dlg.DoModal();

  //Play the shutdown sound
  m_SoundsManager.PlaySound(IDR_SHUTDOWN_SOUND, SND_SYNC);

#ifdef _DEBUG
  //Test out the Unregistration support when in DEBUG mode
  m_SoundsManager.UnRegister();
#endif

  return FALSE;
}
