#include "stdafx.h"
#include "TestSounds.h"
#include "TestSoundsDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestSoundsDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_PLAYSTARTUP, &CTestSoundsDlg::OnBnClickedPlaystartup)
  ON_BN_CLICKED(IDC_PLAYSHUTDOWN, &CTestSoundsDlg::OnBnClickedPlayshutdown)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CTestSoundsDlg::CTestSoundsDlg(_In_opt_ CWnd* pParent) : CDialog{CTestSoundsDlg::IDD, pParent},
                                                         m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

BOOL CTestSoundsDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  //Set the icon for this dialog
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //Display the current values of the 2 sounds
  ATL::CAtlString sSound;
  if (SUCCEEDED(theApp.m_SoundsManager.GetCurrentSoundFromRegistry(IDR_STARTUP_SOUND, sSound)))
    GetDlgItem(IDC_CURRENT_STARTUP_SOUND)->SetWindowText(sSound);

  if (SUCCEEDED(theApp.m_SoundsManager.GetCurrentSoundFromRegistry(IDR_SHUTDOWN_SOUND, sSound)))
    GetDlgItem(IDC_CURRENT_SHUTDOWN_SOUND)->SetWindowText(sSound);

  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestSoundsDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this}; //device context for painting

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CTestSoundsDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestSoundsDlg::OnBnClickedPlaystartup()
{
  theApp.m_SoundsManager.PlaySound(IDR_STARTUP_SOUND, SND_ASYNC);
}

void CTestSoundsDlg::OnBnClickedPlayshutdown()
{
  theApp.m_SoundsManager.PlaySound(IDR_SHUTDOWN_SOUND, SND_ASYNC);
}
